Codeforces Round #470 (前缀和+二分查找+树状数组)

C. Producing Snow
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Alice likes snow a lot! Unfortunately, this year's winter is already over, and she can't expect to have any more of it. Bob has thus bought her a gift — a large snow maker. He plans to make some amount of snow every day. On day i he will make a pile of snow of volume Vi and put it in her garden.

Each day, every pile will shrink a little due to melting. More precisely, when the temperature on a given day is Ti, each pile will reduce its volume by Ti. If this would reduce the volume of a pile to or below zero, it disappears forever. All snow piles are independent of each other.

Note that the pile made on day i already loses part of its volume on the same day. In an extreme case, this may mean that there are no piles left at the end of a particular day.

You are given the initial pile sizes and the temperature on each day. Determine the total volume of snow melted on each day.

Input

The first line contains a single integer N (1 ≤ N ≤ 105) — the number of days.

The second line contains N integers V1, V2, ..., VN (0 ≤ Vi ≤ 109), where Vi is the initial size of a snow pile made on the day i.

The third line contains N integers T1, T2, ..., TN (0 ≤ Ti ≤ 109), where Ti is the temperature on the day i.

Output

Output a single line with N integers, where the i-th integer represents the total volume of snow melted on day i.

Examples
input
Copy
3
10 10 5
5 7 2
output
5 12 4
input
Copy
5
30 25 20 15 10
9 10 12 4 13
output
9 20 35 11 25
Note

In the first sample, Bob first makes a snow pile of volume 10, which melts to the size of 5 on the same day. On the second day, he makes another pile of size 10. Since it is a bit warmer than the day before, the first pile disappears completely while the second pile shrinks to 3. At the end of the second day, he has only a single pile of size 3. On the third day he makes a smaller pile than usual, but as the temperature dropped too, both piles survive till the end of the day.

题解:可能是我太弱了吧,我感觉这道题,有点难o(╥﹏╥)o,想了好久加参考了大佬的代码才稍微领悟些许,可以先用一个前缀和数组记录消耗雪t[i]的前i项和sum[i],然后便可二分查找在第pos天这堆雪被消耗完,不过需要判断在最后一天的时候这堆雪是已经被消耗了,还是没被消耗,用数组ans来记录答案,在这个过程中用树状数组来更新区间。


#include<stdio.h>
#include <algorithm>
#include<iostream>
#include<string.h>
#include<vector>
#include<stdlib.h>
#include<math.h>
#include<queue>
#include<deque>
#include<ctype.h>
#include<map>
#include<set>
#include<stack>
#include<string>
#include<algorithm>
#define ll long long
#define INF 0x3f3f3f3f
#define FAST_IO ios::sync_with_stdio(false)
using namespace std;
 int n;
ll v[100005],t[100005],a[100005],sum[100005],ans[100005];

int lowbit(int x)
{
    return x&(-x);
}

void update(int x,int y)
{
    for(int i=x;i<=n;i+=lowbit(i))
        a[i]+=y;
}

int getsum(int x)
{
    int ans=0;
    for(int i=x;i>0;i-=lowbit(i))
        ans+=a[i];
    return ans;
}

int main()
{

    cin>>n;

    for(int i=1;i<=n;i++)
        cin>>v[i];

    for(int i=1;i<=n;i++)
    {
        cin>>t[i];
        sum[i]=sum[i-1]+t[i];
    }

    for(int i=1;i<=n;i++)
    {
        ll temp=v[i]+sum[i-1];
        int pos=lower_bound(sum+1,sum+1+n,temp)-sum;
        if(i<pos)
        {
            update(pos,-1);
            update(i,1);
        }
        if(i<=pos)
        {
            if(sum[pos]<temp)
                ans[pos]+=t[pos];
            else
                ans[pos]+=v[i]-(sum[pos-1]-sum[i-1]);
        }
    }
    for(int i=1;i<=n;i++)
        ans[i]+=t[i]*getsum(i);

    for(int i=1;i<=n;i++)
        cout<<ans[i]<<" ";

    return 0;
}


评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值